unit mbm_main;
{ Code for creating icon comes from a TI originally (I think)
Overall this example is still a bit messy with bits of trial code commented out
copyright Alec Ford 2001}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Bitmapbase: TButton;
    BitmaoOverlay: TButton;
    MergeBitmaps: TButton;
    OpenDialog1: TOpenDialog;
    Button4: TButton;
    LoadIcon: TButton;
    SaveDialog1: TSaveDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    Button5: TButton;
    SaveIcon: TButton;
    Image4: TImage;
    procedure BitmapbaseClick(Sender: TObject);
    procedure BitmaoOverlayClick(Sender: TObject);
    procedure MergeBitmapsClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure LoadIconClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure SaveIconClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var
floodcolor : Tcolor;
 Icon : TIcon;

procedure TForm1.BitmapbaseClick(Sender: TObject);
var i,j : integer;
begin
OpenPictureDialog1.filterindex := 4;
    if OpenPictureDialog1.execute then
    begin
        Image1.picture.loadfromfile(OpenPictureDialog1.filename );
         Image3.picture.loadfromfile(OpenPictureDialog1.filename );

// 	image3.canvas.draw(0,0,image1.picture.bitmap);
{ this code would shift the bitmap image 3 pixels down within the image
for i := 0 to 31 do
for j := 0 to 28 do
begin
            Image3.canvas.pixels[i,j+3] := Image1.canvas.pixels[i,j];
end;}
end;
end;

procedure TForm1.BitmaoOverlayClick(Sender: TObject);
begin                                                
        if OpenPictureDialog1.execute then
    begin
        Image2.picture.loadfromfile(OpenPictureDialog1.filename );
    end;
end;

procedure TForm1.MergeBitmapsClick(Sender: TObject);
var i,j : integer;
begin
for i := 0 to 31 do
for j := 0 to 31 do
begin
	if Image2.canvas.pixels[i,j] <> Image1.canvas.pixels[1,1] then
            Image3.canvas.pixels[i,j] := Image2.canvas.pixels[i,j];
end;

image4.picture:= image3.picture;
// flood the bitmap from each side to make sure all white outside becomes
//transparent when creating Icon
image3.canvas.brush.color := floodcolor;
for i := 0 to 31 do  //overkill in most cases but covers all edge points
begin
	image3.canvas.FloodFill(0, i, clwhite, fsSurface);
	image3.canvas.FloodFill(31, i, clwhite, fsSurface);
	image3.canvas.FloodFill(i, 0, clwhite, fsSurface);
	image3.canvas.FloodFill(i, 31, clwhite, fsSurface);
end;

end;

procedure TForm1.Button4Click(Sender: TObject);
VAr ic : Ticon;
begin
     if SavePictureDialog1.execute then
    { begin
         ic := Ticon.create;
	ic.free;
     end;      }
     SavePictureDialog1.filename := changefileext(SavePictureDialog1.filename,'.bmp');
     Image4.picture.savetofile(SavePictureDialog1.filename )
end;

procedure TForm1.LoadIconClick(Sender: TObject);
VAr ic : Ticon;
begin
OpenDialog1.filterindex := 2;
    if OpenDialog1.execute then
    begin
    ic := Ticon.create;
        ic.loadfromfile(OpenDialog1.filename );
 	image3.canvas.draw(0,0,ic);
     end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
i,j : integer;
  IconSizeX : integer;
  IconSizeY : integer;
  AndMask : TBitmap; // b&w bitmap white will be the transparent area
  XOrMask : TBitmap; // the color image corrosponding to the black area in above
  IconInfo : TIconInfo;
 begin
 {Get the icon size}
  IconSizeX := GetSystemMetrics(SM_CXICON);
  IconSizeY := GetSystemMetrics(SM_CYICON);

 {Create the "And" mask}
  AndMask := TBitmap.Create;
  AndMask.Monochrome := true;
  AndMask.Width := IconSizeX;
  AndMask.Height := IconSizeY;
   //AndMask.pixelformat := pf8bit;

 {Draw on the "And" mask}
  AndMask.Canvas.Brush.Color := clWhite;
  AndMask.Canvas.FillRect(Rect(0, 0, IconSizeX, IconSizeY));
  AndMask.Canvas.Brush.Color := clBlack;
 // AndMask.Canvas.Ellipse(4, 4, IconSizeX - 8, IconSizeY - 8);
{ for i := 0 to 31 do
for j := 0 to 31 do
begin
	if Image3.canvas.pixels[i,j] <> clwhite then
            AndMask.canvas.pixels[i,j] := Image3.canvas.pixels[i,j];
end;
 {Draw as a test}
 // Form1.Canvas.Draw(IconSizeX * 2, IconSizeY, AndMask);

 {Create the "XOr" mask}
  XOrMask := TBitmap.Create;
  XOrMask.Monochrome := false;//true;
  XOrMask.Width := IconSizeX;
  XOrMask.Height := IconSizeY;
  //XOrMask.pixelformat := pf8bit;

 {Draw on the "XOr" mask}
  XOrMask.Canvas.Brush.Color := ClBlack;
  XOrMask.Canvas.FillRect(Rect(0, 0, IconSizeX, IconSizeY));
  XOrMask.Canvas.Pen.Color := clRed;
  XOrMask.Canvas.Brush.Color := clRed;
 // XOrMask.Canvas.Ellipse(4, 4, IconSizeX - 4, IconSizeY - 4);
 // copyrect(rect(0,0,31,31),Image3.canvas,XOrMask.Canvas)

for i := 0 to 31 do
for j := 0 to 31 do
begin
	if Image3.canvas.pixels[i,j] <> floodcolor then
        begin
            XOrMask.canvas.pixels[i,j] := Image4.canvas.pixels[i,j];
 //           AndMask.canvas.pixels[i,j] := Image3.canvas.pixels[i,j];
            AndMask.canvas.pixels[i,j] := clblack;
            end;
end;
//  XOrMask.Canvas.Ellipse(4, 4, IconSizeX - 4, IconSizeY - 4);
 
//XOrMask.Canvas.CopyRect(rect(0,0,31,31),Image3.Canvas, rect(0,0,31,31));
{ for i := 1 to 31 do
for j := 1 to 31 do
begin
	if Image3.canvas.pixels[i,j] <> Image3.canvas.pixels[1,1] then
            XOrMask.canvas.pixels[i,j] := Image3.canvas.pixels[i,j];
end;}

 {Draw as a test}
  Form1.Canvas.Draw(IconSizeX * 2 +50, 150+IconSizeY, AndMask);
 Form1.Canvas.Draw(IconSizeX * 4 +50 ,150+IconSizeY, XOrMask);

 {Create a icon}
  Icon := TIcon.Create;
  icon.transparent := true;
  IconInfo.fIcon := true;
  IconInfo.xHotspot := 0;
  IconInfo.yHotspot := 0;
  IconInfo.hbmMask := AndMask.Handle;
  IconInfo.hbmColor := XOrMask.Handle;
  Icon.Handle := CreateIconIndirect(IconInfo);

 {Destroy the temporary bitmaps}
  AndMask.Free;
  XOrMask.Free;

 {Draw as a test}
  Form1.Canvas.Draw(IconSizeX * 6 + 50, 150 +IconSizeY, Icon);

 {Assign the application icon}
  //Application.Icon := Icon;

//
 {Force a repaint}
  InvalidateRect(Application.Handle, nil, true);


end;
procedure TForm1.SaveIconClick(Sender: TObject);
var fn : string;
begin
SavePictureDialog1.initialdir :=  extractfilepath(OpenPictureDialog1.filename);
SavePictureDialog1.filterindex := 5;
  if SavePictureDialog1.execute then
  begin
	fn := changefileext(SavePictureDialog1.filename,'.ico');
  	icon.savetofile(SavePictureDialog1.filename);
  end;
end;

initialization

//define this to be a color not in either bitmap so
floodcolor := clblue;
Icon := TIcon.Create;
finalization
 {Free the icon}
  Icon.Free;

end.

